<template>
  <div role="radiogroup">
    <label
      :aria-label="`${card.name} Expired ${card.expiry}`"
      :aria-checked="selecetdCard.paymentToken == card.paymentToken"
      class="flex border rounded-md md:w-460 md:h-15 lg:w-610 px-4 py-4 my-4 justify-between cursor-pointer mb-0"
      v-for="(card, index) in creditCards"
      :for="'address_id' + index"
      :class="[
        selecetdCard.paymentToken == card.paymentToken
          ? 'border-black'
          : 'border-grey-20',
        card.expiredStatus ? 'focus:outline-none' : 'focus:border-grey-40',
      ]"
      :key="`${card.name}_${index}`"
      @click="updateSelectedCard(card)"
      @keypress.enter="updateSelectedCard(card)"
    >
    <input class="absolute opacity-0" name="address_list" role="radio" :aria-checked="selecetdCard.paymentToken == card.paymentToken" :tabindex="selecetdCard.paymentToken == card.paymentToken || (index == 0 && !selecetdCard) ? 0 : -1" type="radio" :id="'address_id' + index" />
      <div class="flex">
        <img
          :src="require(`~/assets/images/${card.imageName}`)"
          class="w-10 h-6"
          :alt="`${card.brand} creditcard`"
        />
        <p class="font-primary-font-bold text-base leading-6 pl-4 uppercase">
          {{ card.name }}
        </p>
      </div>
      <div
        class="flex justify-center items-center"
        :class="card.expiredStatus ? 'text-error-20' : ''"
      >
        <p class="font-primary-font-light text-base leading-6">Exp.</p>
        <p
          class="font-primary-bold text-base leading-6 pl-1 md:pl-2.5 lg:pl-1.5"
        >
          {{ card.expiry | monthFormatter }}
        </p>
      </div>
    </label>
  </div>
</template>
<script>
export default {
  name: 'MkCreditCard',
  props: {
    creditCards: {
      type: Array,
      default: () => [],
    },
    cardSelected: {
      type: Object,
      default: () => {},
    },
    recentPayment: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      selecetdCard: {},
    }
  },
  watch: {
    cardSelected() {
      this.selecetdCard = this.cardSelected
    },
    recentPayment() {
      this.setRecentPayment()
    },
  },
  mounted() {
    this.setRecentPayment()
  },
  methods: {
    getFormattedDate($date) {
      return this.$options.filters.ustToDate($date)
    },
    updateSelectedCard(
      cardObject = { paymentToken: '', expiredStatus: false }
    ) {
      if (!cardObject.expiredStatus) {
        this.selecetdCard = cardObject
        this.$emit('selected-card', this.selecetdCard)
      } else {
        this.selecetdCard = {}
        this.$emit('selected-card', this.selecetdCard)
      }
    },
    setRecentPayment() {
      if (this.recentPayment !== '' && !this.cardSelected.paymentToken) {
        const $recentPayment = this.creditCards.filter(($obj) => {
          return $obj.paymentId === this.recentPayment
        })
        this.selecetdCard = $recentPayment[0]
        this.updateSelectedCard($recentPayment[0])
      }
    },
  },
}
</script>
